//
//  initSport.asm
//

#include <def21262.h>


.global _initSPORT;
.global  rx0a_buf, tx1a_buf, tx1b_buf, tx2a_buf, tx2b_buf;

#define Left_channel 0
#define Right_channel 1

.section/dm seg_dmda;
.var rx0a_buf[2]; // receive buffer (DMA)
.var tx1a_buf[2] =  0x00000000,		// transmit buffer (DMA)
				  	0x00000000;
.var tx1b_buf[2] =  0x00000000,		// transmit buffer (DMA)
				  	0x00000000;
.var tx2a_buf[2] =  0x00000000,		// transmit buffer (DMA)
				  	0x00000000;
.var tx2b_buf[2] =  0x00000000,		// transmit buffer (DMA)
				  	0x00000000;
						  	
					  	
				  	

				  	
.var 	rcv0a_tcb[4]  =   0, 2, 1, rx0a_buf;	/* SPORT0A receive tcb */
.var 	xmit1a_tcb[4] =   0, 2, 1, tx1a_buf;  /* SPORT1A transmit tcb */
.var 	xmit1b_tcb[4] =   0, 2, 1, tx1b_buf;  /* SPORT1B transmit tcb */				  					  	 
.var 	xmit2a_tcb[4] =   0, 2, 1, tx2a_buf;  /* SPORT2A transmit tcb */
.var 	xmit2b_tcb[4] =   0, 2, 1, tx2b_buf;  /* SPORT2B transmit tcb */				  	

.section/pm seg_pmco;

_initSPORT:


	//============================================================
	//
	// Make sure that the multichannel mode registers are cleared
	//
	//============================================================
	
	r0 = 0;
	dm(SPMCTL01) = r0;
	dm(SPMCTL23) = r0;

	//============================================================
	//
	// Configure SPORT 0 for input from ADC
	//
	//    BHD = Buffer hang disable
	//    OPMODE = I2S mode
	//    SLEN24 = 24 bit of data in each 32-bit word
	//    SDEN_A = DMA Enable  --new setting for delay line
	//    SPEN_A = Enable data channel A
	//
	//------------------------------------------------------------

	
	r0 = BHD | OPMODE | SLEN32 | SPEN_A| SDEN_A| SCHEN_A;   // 
	dm(SPCTL0) = r0;  


	//============================================================
	//
	// Configure SPORTs 1 & 2 for output to DACs 1-4
	//
	//    SPTRAN = Transmit on serial port
	//    BHD = Buffer hang disable
	//    OPMODE = I2S mode
	//    SLEN24 = 24 bit of data in each 32-bit word
	//    SPEN_A = Enable data channel A
	//    SPEN_A = Enable data channel B
	//    SDEN_A = DMA Enable  --new setting for delay line
	//    SDEN_B = DMA Enable  --new setting for delay line		
	//
	//------------------------------------------------------------

	r0 = SPTRAN | BHD | OPMODE | SLEN32| SPEN_A | SPEN_B | SDEN_A |
	     SDEN_B|SCHEN_A|SCHEN_B ;
	dm(SPCTL1) = r0; 
	dm(SPCTL2) = r0;           // 




/* For the SPORT0A receive DMA chaining */ 
r1 = 0x0007FFFF;  //Chain pointer mask
r0 = rcv0a_tcb + 3; // Get the pointer to the IISP0A
r0 = r1 AND r0; // Mask the pointer

r0 = BSET r0 BY 19; //Set the pci bit

dm(rcv0a_tcb) = r0; //  CPSP0A value in the TCB is set to IISP0A of the same TCB
dm(CPSP0A) = r0;   // Start the receive chaining DMA

/* For the SPORT1A transmit DMA chaining */
r0 = xmit1a_tcb + 3; // Get the pointer to the IISP1A
r0 = r1 AND r0; // Mask the pointer



dm(xmit1a_tcb) = r0; //  CPSP0A value in the TCB is set to IISP1A of the same TCB
dm(CPSP1A) = r0;   // Start the transmit chaining DMA


/* For the SPORT1B transmit DMA chaining */


r0 = xmit1b_tcb + 3; // Get the pointer to the IISP1B
r0 = r1 AND r0; // Mask the pointer



dm(xmit1b_tcb) = r0; //  CPSP0A value in the TCB is set to IISP1B of the same TCB
dm(CPSP1B) = r0;   // Start the receive chaining DMA

/* For the SPORT2A transmit DMA chaining */


r0 = xmit2a_tcb + 3; // Get the pointer to the IISP2A
r0 = r1 AND r0; // Mask the pointer



dm(xmit2a_tcb) = r0; //  CPSP0A value in the TCB is set to IISP2A of the same TCB
dm(CPSP2A) = r0;   // Start the receive chaining DMA

/* For the SPORT2B transmit DMA chaining */


r0 = xmit2b_tcb + 3; // Get the pointer to the IISP2B
r0 = r1 AND r0; // Mask the pointer


dm(xmit2b_tcb) = r0; //  CPSP0A value in the TCB is set to IISP2B of the same TCB
dm(CPSP2B) = r0;   // Start the receive chaining DMA

rts;

_initSPORT.end:








 




