//-----------------------------------------
//   main.asm
//-----------------------------------------
//
//   21262 EZ-KIT Test
//
//-----------------------------------------

#include <def21262.h>

.section /pm seg_pmco;

.global _main;
.extern _initDAI;
.extern _init1835viaSPI;
.extern _initSPORT;
.extern Init_Delay_Buffers;

_main:

    call _initDAI;

    call _init1835viaSPI;
    
    call _initSPORT;
    
    call Init_Delay_Buffers;
    
    ustat1 = dm(SYSCTL);
    
    BIT SET ustat1 IRQ1EN|IRQ2EN;
    
    dm(SYSCTL) = ustat1;           // set flag pins as IRQ pins

    BIT SET MODE2 IRQ1E | IRQ2E;   // make the interrupts edge sensitive
    
   
	IRPTL = 0x00000000;              
   

	//----------------------------------------------
	// Enable interrupts (globally)
	BIT SET MODE1 IRPTEN|NESTM;
	
	 NOP;
	
	
	//----------------------------------------------
	// Unmask the SPORT0 ISR
	 LIRPTL = SP0IMSK;
	
	 BIT SET IMASK IRQ1I|IRQ2I;   // Unmask hardware interrupts 0 and 1;
	    
	
	
	//----------------------------------------------
	// Loop forever.  Work is driven by interrupts
	jump (pc,0);

_main.end:




